<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use \Setforms2\Shared\ORM\DateTime;

class RelBaixaEstoqueProdutoService {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function getReport($conditions) {
    if(!array_key_exists('DTLANCMOVIFIN', $conditions) || !array_key_exists('DTLANCMOVIINI', $conditions)) {
       return array();
    } else {
       $params = array(
     			   ':CDFILIMOVI'      => $conditions['CDFILIMOVI'],
     		    ':DTLANCMOVIFIN'   => $conditions['DTLANCMOVIFIN'],
     		    ':DTLANCMOVIINI'   => $conditions['DTLANCMOVIINI'],
     		    ':CDARVPRODCOMP'   => $conditions['CDARVPRODCOMP'],
     		    ':TCDARVPRODCOMP'  => $conditions['TCDARVPRODCOMP'],
     		    ':CDPRODINICOMP'   => $conditions['PRODINICOMP'],
     		    ':CDPRODFIMCOMP'   => $conditions['PRODFIMCOMP'],
     		    ':CDARVPRODVENDA'  => $conditions['CDARVPRODVENDA'],
     		    ':TCDARVPRODVENDA' => $conditions['TCDARVPRODVENDA'],
     		    ':CDPRODINIVENDA'  => $conditions['PRODINIVENDA'],
     		    ':CDPRODFIMVENDA'  => $conditions['PRODFIMVENDA']
     		);
     		return $this->entityManager->getConnection()->fetchAll(self::GET_BAIXA_ESTOQUE_PRODUTO, $params);
    }
	}

	const GET_BAIXA_ESTOQUE_PRODUTO = "
        SELECT I.CDPRODUTO||' - '||P.NMPRODUTO AS LABELPRODUTO, 
               I.QTLANCTOEST, 
               TO_CHAR(I.DTLANCMOVI, 'DD/MM/YYYY') AS LABELDATA, 
               I.CDFILIMOVI, 
               I.CDPRODPAI, 
               I.QTPRODPAI, 
               I.QTRETIRAOBS, 
               I.QTADICIONAOBS,
               (I.QTTOTLANCTO / I.QTPRODPAI) AS QTRETIRAUN,
               PP.NMPRODUTO AS NMPRODPAI,
               P.CDARVPROD,
               PP.CDARVPROD AS CDARVPRODPAI,
               F.NMFILIAL
        FROM
               ITLANCTOESTREL I
               JOIN PRODUTO P ON
                I.CDPRODUTO = P.CDPRODUTO
               JOIN PRODUTO PP ON
                I.CDPRODPAI = PP.CDPRODUTO
               JOIN FILIAL F ON
                I.CDFILIMOVI = F.CDFILIAL
        WHERE
                I.DTLANCMOVI BETWEEN :DTLANCMOVIINI AND :DTLANCMOVIFIN
                AND I.CDFILIMOVI = :CDFILIMOVI
                AND ((INSTR(:CDARVPRODCOMP, P.CDARVPROD) <> 0) OR (:TCDARVPRODCOMP = 'T') OR (P.CDARVPROD BETWEEN :CDPRODINICOMP AND :CDPRODFIMCOMP))
                AND ((INSTR(:CDARVPRODVENDA, PP.CDARVPROD) <> 0) OR (:TCDARVPRODVENDA = 'T') OR (PP.CDARVPROD BETWEEN :CDPRODINIVENDA AND :CDPRODFIMVENDA))
       ORDER BY I.CDPRODPAI";
}
